# std::multiset< Key, Compare, Alloc > Class Template Reference
[Containers, Associative Containers]

A standard container made up of elements, which can be retrieved in logarithmic time. More...

`#include <stl_multiset.h>`

Inheritance diagram for std::multiset< Key, Compare, Alloc >:

[legend]
List of all members.

## [NOHEADER]

pair< iterator, iterator > | equal_range (const key_type &x)
| Finds a subsequence matching given key.
pair< const_iterator, const_iterator > | equal_range (const key_type &x) const
| Finds a subsequence matching given key.
template<class K1, class C1, class A1> bool | operator== (const multiset< K1, C1, A1 > &, const multiset< K1, C1, A1 > &)
| Finds a subsequence matching given key.
template<class K1, class C1, class A1> bool | operator< (const multiset< K1, C1, A1 > &, const multiset< K1, C1, A1 > &)
| Finds a subsequence matching given key.

## Public Member Functions

| multiset ()
| Default constructor creates no elements.
template<class InputIterator> | multiset (InputIterator first, InputIterator last)
| Builds a multiset from a range.
template<class InputIterator> | multiset (InputIterator first, InputIterator last, const Compare &comp, const allocator_type &a=allocator_type())
| Builds a multiset from a range.
| multiset (const multiset< Key, Compare, Alloc > &x)
| Multiset copy constructor.
multiset< Key, Compare, Alloc > & | operator= (const multiset< Key, Compare, Alloc > &x)
| Multiset assignment operator.
key_compare | key_comp () const
| Returns the comparison object.
value_compare | value_comp () const
| Returns the comparison object.
allocator_type | get_allocator () const
| Returns the memory allocation object.
iterator | begin () const
iterator | end () const
reverse_iterator | rbegin () const
reverse_iterator | rend () const
bool | empty () const
| Returns true if the set is empty.
size_type | size () const
| Returns the size of the set.
size_type | max_size () const
| Returns the maximum size of the set.
void | swap (multiset< Key, Compare, Alloc > &x)
| Swaps data with another multiset.
iterator | insert (const value_type &x)
| Inserts an element into the multiset.
iterator | insert (iterator position, const value_type &x)
| Inserts an element into the multiset.
template<class InputIterator> void | insert (InputIterator first, InputIterator last)
| A template function that attemps to insert a range of elements.
void | erase (iterator position)
| Erases an element from a multiset.
size_type | erase (const key_type &x)
| Erases elements according to the provided key.
void | erase (iterator first, iterator last)
| Erases a [first,last) range of elements from a multiset.
void | clear ()
size_type | count (const key_type &x) const
| Finds the number of elements with given key.
iterator | find (const key_type &x)
| Tries to locate an element in a set.
const_iterator | find (const key_type &x) const
| Tries to locate an element in a set.
iterator | lower_bound (const key_type &x)
| Finds the beginning of a subsequence matching given key.
const_iterator | lower_bound (const key_type &x) const
| Finds the beginning of a subsequence matching given key.
iterator | upper_bound (const key_type &x)
| Finds the end of a subsequence matching given key.
const_iterator | upper_bound (const key_type &x) const
| Finds the end of a subsequence matching given key.

## Detailed Description

### template<class Key, class Compare, class Alloc>
class std::multiset< Key, Compare, Alloc >

A standard container made up of elements, which can be retrieved in logarithmic time.

Meets the requirements of a container, a reversible container, and an associative container (using equivalent keys). For a `multiset<Key>` the key_type and value_type are Key.

Multisets support bidirectional iterators.

Definition at line 105 of file stl_multiset.h.

## Constructor & Destructor Documentation

template<class Key, class Compare, class Alloc>
std::multiset< Key, Compare, Alloc >::multiset | ( |  | ) | `[inline]`

| Default constructor creates no elements. Definition at line 147 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
template<class InputIterator>
std::multiset< Key, Compare, Alloc >::multiset | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Builds a multiset from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a multiset consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 165 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
template<class InputIterator>
std::multiset< Key, Compare, Alloc >::multiset | ( | InputIterator | first,
|  | InputIterator | last,
|  | const Compare & | comp,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Builds a multiset from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | comp | A comparison functor.
  | a | An allocator object.

Create a multiset consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 181 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
std::multiset< Key, Compare, Alloc >::multiset | ( | const multiset< Key, Compare, Alloc > & | x | ) | `[inline]`

Multiset copy constructor.

Parameters:

  | x | A multiset of identical element and allocator types.

The newly-created multiset uses a copy of the allocation object used by x.

Definition at line 194 of file stl_multiset.h.

## Member Function Documentation

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read/write iterator that points to the first element in the multiset. Iteration is done in ascending order according to the keys. Definition at line 232 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
void std::multiset< Key, Compare, Alloc >::clear | ( |  | ) | `[inline]`

| Erases all elements in a multiset. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 405 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
size_type std::multiset< Key, Compare, Alloc >::count | ( | const key_type & | x | ) | const`[inline]`

Finds the number of elements with given key.

Parameters:

  | x | Key of elements to be located.

Returns:
  Number of elements with specified key.

Definition at line 416 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
bool std::multiset< Key, Compare, Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the set is empty. Definition at line 264 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read/write iterator that points one past the last element in the multiset. Iteration is done in ascending order according to the keys. Definition at line 241 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
pair<const_iterator,const_iterator> std::multiset< Key, Compare, Alloc >::equal_range | ( | const key_type & | x | ) | const`[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 500 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
pair<iterator,iterator> std::multiset< Key, Compare, Alloc >::equal_range | ( | const key_type & | x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 496 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
void std::multiset< Key, Compare, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) | `[inline]`

Erases a [first,last) range of elements from a multiset.

Parameters:

  | first | Iterator pointing to the start of the range to be erased.
  | last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a multiset. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 392 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
size_type std::multiset< Key, Compare, Alloc >::erase | ( | const key_type & | x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  | x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all elements located by the given key from a multiset. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 377 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
void std::multiset< Key, Compare, Alloc >::erase | ( | iterator | position | ) | `[inline]`

Erases an element from a multiset.

Parameters:

  | position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a multiset. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 359 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
const_iterator std::multiset< Key, Compare, Alloc >::find | ( | const key_type & | x | ) | const`[inline]`

Tries to locate an element in a set.

Parameters:

  | x | Element to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 438 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::find | ( | const key_type & | x | ) | `[inline]`

Tries to locate an element in a set.

Parameters:

  | x | Element to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 434 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
allocator_type std::multiset< Key, Compare, Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Returns the memory allocation object. Definition at line 223 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
template<class InputIterator>
void std::multiset< Key, Compare, Alloc >::insert | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

A template function that attemps to insert a range of elements.

Parameters:

  | first | Iterator pointing to the start of the range to be inserted.
  | last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 345 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::insert | ( | iterator | position,
|  | const value_type & | x
| ) | `[inline]`

Inserts an element into the multiset.

Parameters:

  | position | An iterator that serves as a hint as to where the element should be inserted.
  | x | Element to be inserted.

Returns:
  An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on "hinting".

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 329 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::insert | ( | const value_type & | x | ) | `[inline]`

Inserts an element into the multiset.

Parameters:

  | x | Element to be inserted.

Returns:
  An iterator that points to the inserted element.

This function inserts an element into the multiset. Contrary to a std::set the multiset does not rely on unique keys and thus multiple copies of the same element can be inserted.

Insertion requires logarithmic time.

Definition at line 305 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
key_compare std::multiset< Key, Compare, Alloc >::key_comp | ( |  | ) | const`[inline]`

| Returns the comparison object. Definition at line 215 of file stl_multiset.h. Referenced by std::multiset< Key, Compare, Allocator >::key_comp().

template<class Key, class Compare, class Alloc>
const_iterator std::multiset< Key, Compare, Alloc >::lower_bound | ( | const key_type & | x | ) | const`[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 459 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::lower_bound | ( | const key_type & | x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 455 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
size_type std::multiset< Key, Compare, Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the maximum size of the set. Definition at line 274 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
multiset<Key,Compare,Alloc>& std::multiset< Key, Compare, Alloc >::operator= | ( | const multiset< Key, Compare, Alloc > & | x | ) | `[inline]`

Multiset assignment operator.

Parameters:

  | x | A multiset of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 205 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
reverse_iterator std::multiset< Key, Compare, Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read/write reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys. Definition at line 250 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
reverse_iterator std::multiset< Key, Compare, Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read/write reverse iterator that points to the last element in the multiset. Iteration is done in descending order according to the keys. Definition at line 259 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
size_type std::multiset< Key, Compare, Alloc >::size | ( |  | ) | const`[inline]`

| Returns the size of the set. Definition at line 269 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
void std::multiset< Key, Compare, Alloc >::swap | ( | multiset< Key, Compare, Alloc > & | x | ) | `[inline]`

Swaps data with another multiset.

Parameters:

  | x | A multiset of the same element and allocator types.

This exchanges the elements between two multisets in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 289 of file stl_multiset.h.

Referenced by std::swap().

template<class Key, class Compare, class Alloc>
const_iterator std::multiset< Key, Compare, Alloc >::upper_bound | ( | const key_type & | x | ) | const`[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Definition at line 475 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
iterator std::multiset< Key, Compare, Alloc >::upper_bound | ( | const key_type & | x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Definition at line 471 of file stl_multiset.h.

template<class Key, class Compare, class Alloc>
value_compare std::multiset< Key, Compare, Alloc >::value_comp | ( |  | ) | const`[inline]`

| Returns the comparison object. Definition at line 219 of file stl_multiset.h.

## Friends And Related Function Documentation

template<class Key, class Compare, class Alloc>
template<class K1, class C1, class A1>
bool operator< | ( | const multiset< K1, C1, A1 > & | ,
|  | const multiset< K1, C1, A1 > & |
| ) | `[friend]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

template<class Key, class Compare, class Alloc>
template<class K1, class C1, class A1>
bool operator== | ( | const multiset< K1, C1, A1 > & | ,
|  | const multiset< K1, C1, A1 > & |
| ) | `[friend]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

The documentation for this class was generated from the following file:

- stl_multiset.h